private void cutNode_Click(object sender, EventArgs e)
		{
			
			NodeCollection removeColl = new NodeCollection();
			ArrayList delCol = new ArrayList();
			int index = 0;
			bool find1 = false;
			bool find2 = false;
			bool find3 = false;
			
			
			//clear the GlobalCutlist and GlobalPasteList
			//before start of any Cut Operation ------ GlobalPasteList/CutList contains the objects
			//that are cut and that have to be pasted. 
			
			Main.GlobalCutList.Clear();
			Main.GlobalPasteList.Clear();
			NodeCollection selectionColl = diagram.Controller.SelectionList;
			IEnumerator findLinknodes = selectionColl.GetEnumerator();

			while (findLinknodes.MoveNext())
			{
				if (findLinknodes.Current.GetType() == typeof(FunctionBlock))
				{
					ICollection lnkCollection = ((FunctionBlock)findLinknodes.Current).Connections;
					IEnumerator lnkCollectionEnum = lnkCollection.GetEnumerator();
					Link newlink = null; 
					while(lnkCollectionEnum.MoveNext())
					{	
						 
						if (((Syncfusion.Windows.Forms.Diagram.Connection)lnkCollectionEnum.Current).SourcePort is LinkPort)
						{
							newlink = ((Syncfusion.Windows.Forms.Diagram.Connection)lnkCollectionEnum.Current).SourcePort.Container as Link;
						}
						else if (((Syncfusion.Windows.Forms.Diagram.Connection)lnkCollectionEnum.Current).TargetPort is LinkPort)
						{
							newlink = ((Syncfusion.Windows.Forms.Diagram.Connection)lnkCollectionEnum.Current).TargetPort.Container as Link;
						}
						Main.GlobalCutList.Add((Connection)newlink);
					}
				}
			}
		
			
			//reset since it has to be reused
			findLinknodes.Reset();
			
			#region logic to seperate collections
			Object[] myObjArray = new Object[Main.GlobalCutList.Count];
			Object[] mynewObjArray = new Object[Main.GlobalCutList.Count];
			Object[] myGlobalObjArray = new Object[selectionColl.Count];
			ArrayList myGlobalObjList = new ArrayList();
			Main.GlobalCutList.CopyTo(myObjArray,0);
			selectionColl.CopyTo(myGlobalObjArray,0);
			
			//copy to arraylist for forming a removable collection
			for (int cnt1=0; cnt1 < myGlobalObjArray.Length;cnt1++)
			{
				myGlobalObjList.Add(myGlobalObjArray.GetValue(cnt1));
			}
			
			//logic to remove links from the Global Arraylist if the FromNode or ToNode is 
			// not selected
			for (int cntr = 0; cntr < myGlobalObjList.Count; cntr++)
			{
				if (myGlobalObjList[cntr].GetType() == typeof(Connection))
				{
					if (((IList)myGlobalObjList).Contains(((Connection)myGlobalObjList[cntr]).FromNode))
					{
						find1 = true;
					}
					if (((IList)myGlobalObjList).Contains(((Connection)myGlobalObjList[cntr]).ToNode))
					{
						find2 = true;
					}
					if (find1 == true && find2 == true)
					{
						find3 = true;
					}
					if (find3 == false)
					{
						removeColl.Add(((Connection)myGlobalObjList[cntr]));
						find1 = false;
						find2 = false;
					}
				}
			}
			#endregion

			for (int cnt2=0; cnt2 < removeColl.Count; cnt2++)
			{
				myGlobalObjList.Remove(removeColl[cnt2]);
			}
			
			//clearing as we are reusing the collection
			removeColl.Clear();

			myGlobalObjArray = myGlobalObjList.ToArray();
			
			//logic to find whether a link is not available in the Global Array
			for (int cnt3 = 0; cnt3 < myObjArray.Length; cnt3++)
			{
				if (!((IList)myGlobalObjArray).Contains(myObjArray.GetValue(cnt3)))
				{
					index++;
					delCol.Add(myObjArray.GetValue(cnt3));
				}
				else
				{
					if (!((IList)Main.GlobalPasteList).Contains((Connection)myObjArray.GetValue(cnt3)))
						Main.GlobalPasteList.Add((Connection)myObjArray.GetValue(cnt3));
				}
			}

			((IList)myObjArray).Clear();
			delCol.CopyTo(myObjArray,0);
			Main.GlobalCutList.Clear();

			for (int cnt4 = 0; cnt4 < myObjArray.Length; cnt4++)
			{
				if (((Connection)myObjArray.GetValue(cnt4)) != null)
					Main.GlobalCutList.Add(((Connection)myObjArray.GetValue(cnt4)));
			}

			//findLinknodes.Reset();

			//TODO: To look at why funny things happen with Syncfusion
			//while just changing the Style of a FunctionBlock			
			for (int j=0; j < selectionColl.Count  ; j++)
			{
				if (selectionColl[j].GetType() == typeof(FunctionBlock))
				{
					Object selectedObject = selectionColl[j];
					Main.GlobalCutList.Add(((FunctionBlock)selectionColl[j]));
					Main.GlobalPasteList.Add(((FunctionBlock)selectionColl[j]));
					Main.CutOperationPerformed = true;
				}
			}

			//Changing the style of the Objects Cut to DashStyle. Only the functionblock style is changed
			for (int k = 0; k < Main.GlobalCutList.Count; k++)
			{
				if (Main.GlobalCutList[k].GetType() == typeof(FunctionBlock))
				{
					((FunctionBlock)Main.GlobalCutList[k]).LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Dot;
				}
			}

			diagram.Controller.ClearHistory();
		}
		


		/// <summary>
		/// Helper method to connect the links between
		/// Symbols when they are pasted ..... This isn't working as expected
		/// </summary>
		/// <param name="nodes"></param>
		/// <returns>null</returns>
		private void ConnectLinkedNodes(NodeCollection nodes)
		{
			ArrayList links = new ArrayList();
			ArrayList symbols = new ArrayList();
			foreach(INode node in nodes)
			{
				if(node is Link)
					links.Add(node);
				else if(node is Symbol)
					symbols.Add(node);
			}

			foreach(Link currlink in links)
			{
				for(int i=currlink.Connections.Count-1; i>=0; i--)
				{					
					Syncfusion.Windows.Forms.Diagram.Connection srcconnection = currlink.Connections[i];
					foreach(Symbol currsymbol in symbols)
					{						
						if(currsymbol.Connections.Contains(srcconnection) == true)
						{
							Port srcport;
							Port targetport;							
							if(srcconnection.SourcePort is LinkPort)
							{
								targetport = currsymbol.CenterPort;
								srcport = (srcconnection.SourcePort is LinkHeadPort) ? currlink.HeadPort : currlink.TailPort;
							}
							else // srcconnection.TargetPort is LinkPort
							{
								srcport = currsymbol.CenterPort;
								targetport = (srcconnection.TargetPort is LinkHeadPort) ? currlink.HeadPort : currlink.TailPort;
							}
							currlink.Connections.Remove(srcconnection);
							currsymbol.Connections.Remove(srcconnection);
							currlink.Connect(srcport, targetport);
						}						
					}
				}
			}			
		}


/// <summary>
		/// The event handler that is invoked onclick of Paste 
		/// from the Context Menu
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <returns>void</returns>
		private void pasteItem_Click(object sender, EventArgs e)
		{
			//Call this loop when Paste is done after the Copy
			if (Main.CopyOperationPerformed)
			{
				//((WorkSheet)(((Control)((diagram.Parent))))).ActiveDiagram.Controller.Paste(
								//diagram.Model.DefaultLayerName, diagram.Controller.MouseLocation);
				Diagram currentDiagram = ((WorkSheet)(((Control)((diagram.Parent))))).ActiveDiagram;
				InsertNodesCmd insertCmd = null;
				ClipboardNodeCollection clipboardNodes = null;
				IDataObject clipboardData = Clipboard.GetDataObject();
				if(clipboardData.GetDataPresent(typeof(ClipboardNodeCollection)))
				{
					clipboardNodes = (ClipboardNodeCollection) clipboardData.GetData(typeof(ClipboardNodeCollection));
						
					if((clipboardNodes != null) && (clipboardNodes.Count > 0)) 
					{
						insertCmd = new InsertNodesCmd();
						insertCmd.LayerName = currentDiagram.Model.DefaultLayerName;
						insertCmd.Nodes.Concat(clipboardNodes);
						currentDiagram.ExecuteCommand(insertCmd);

						//TODo: This function is called to move the link 
						//attached to the Pasted Nodes
						ConnectLinkedNodes(clipboardNodes);
							
						foreach(INode node in clipboardNodes)
						{
							if (node.GetType() == typeof(FunctionBlock))
							{
								((FunctionBlock)node).WorkSheetId = this.Text;
							}
							IBounds2DF bounds = node as IBounds2DF;						
							if(bounds != null)
							{
								PointF worldpoint = currentDiagram.Controller.MouseLocation;
								if(currentDiagram.View != null)
									worldpoint = currentDiagram.View.ViewToWorld(currentDiagram.View.DeviceToView(new Point((int)currentDiagram.Controller.MouseLocation.X, (int)currentDiagram.Controller.MouseLocation.Y)));
								MoveCmd movenodescmd = new MoveCmd(worldpoint.X-bounds.X, worldpoint.Y-bounds.Y);
								movenodescmd.Nodes.Concat(clipboardNodes);
								currentDiagram.ExecuteCommand(movenodescmd);
								currentDiagram.Controller.SelectionList.Add(node);
							}
						}					
					}
				}	
				diagram.Model.UpdateViews();
				Main.CutOperationPerformed = false;
				Main.CopyOperationPerformed = false;
				this.PastePerformed = false;
			}
			else //call this loop if paste is done after Cut
			{
				//clear the diagram selection list first
				diagram.Controller.SelectionList.Clear();
				
				int pasteCnt = Main.GlobalPasteList.Count;
				int cutCnt = Main.GlobalCutList.Count;
				
				NodeCollection globalCollection = new NodeCollection();
				globalCollection = diagram.Controller.SelectionList;
				
				this.PastePerformed = true;

				if (cutCnt > 0)
				{
					//Clear the SelectionList and create the
					//contents in the SelectionList with the
					//contents from GlobalCutList.
					INode curNode;	
					globalCollection.Clear();
					foreach (INode tempCurNode in (NodeCollection)Main.GlobalCutList)
					{
						curNode = tempCurNode;
						globalCollection.Add(curNode);
					}
				
					//Call the utility function to remove links 
					//if any from the GlobalCutList
					RemoveLinks((NodeCollection)Main.GlobalCutList);
					diagram.Refresh();
				
					//While removing links from diagram many items are getting cleared
					//Check this later. This loop is to repopulate the SelectionList
					globalCollection.Clear();
					foreach (INode tempCurNode in (NodeCollection)Main.GlobalCutList)
					{
						curNode = tempCurNode;
						if (curNode.GetType() == typeof(FunctionBlock))
						{
							globalCollection.Add(curNode);
						}
					}

					//code added on Dec 12th
                    #region copy to clipboard
					//logic to populate the Cut Items to the ClipBoard
					diagram.Controller.SelectionList.Clear();
					for (int h = 0; h < pasteCnt; h++)
					{
						diagram.Controller.SelectionList.Add(Main.GlobalPasteList[h]);
					}
					//This will copy the selected items to the ClipBoard
					diagram.Controller.Copy();
					#endregion
										
					//Get the Worksheet from which the Object has to be deleted
					WorkSheet objWorkSheet = null;
					//If the first Object in the Cut Array is a functionblock
					if (Main.GlobalPasteList[0].GetType() == typeof(FunctionBlock))
					{
						objWorkSheet = MainHelper.GetWorkSheet(((FunctionBlock)Main.GlobalPasteList[0]).WorkSheetId);
					}
					else //if the first Object in the Cut Array is a link
					{
						objWorkSheet = MainHelper.GetWorkSheet(((FunctionBlock)((Connection)Main.GlobalPasteList[0]).FromNode).WorkSheetId);
					}
					//Clear any objects in the selectionlist before deleting
					//and then populate the selectionlist again
					objWorkSheet.diagram.SelectionList.Clear();
					for (int h = 0; h < pasteCnt; h++)
					{
						objWorkSheet.diagram.Controller.SelectionList.Add(Main.GlobalPasteList[h]);
					}				
					int removeCnt = objWorkSheet.diagram.SelectionList.Count;
					//loop thru the list to delete the objects from the Worksheet 
					//from where it was cut
					for (int removeCntr = 0; removeCntr < removeCnt; removeCntr++)
					{
						int childIndex = objWorkSheet.diagram.Model.GetChildIndex(Main.GlobalPasteList[removeCntr]);
						objWorkSheet.diagram.Model.RemoveChild(childIndex);
					}

					//Get the Active Worksheet's diagram
					Diagram currentDiagram = ((WorkSheet)(((Control)((diagram.Parent))))).ActiveDiagram;
					
					#region Get the nodes from the Clipboard and Paste into the worksheet
					//logic to get the objects that has been copied to the clipboard
					InsertNodesCmd insertCmd = null;
					ClipboardNodeCollection clipboardNodes = null;
					IDataObject clipboardData = Clipboard.GetDataObject();
					if(clipboardData.GetDataPresent(typeof(ClipboardNodeCollection)))
					{
						clipboardNodes = (ClipboardNodeCollection) clipboardData.GetData(typeof(ClipboardNodeCollection));
						
						if((clipboardNodes != null) && (clipboardNodes.Count > 0)) 
						{
							insertCmd = new InsertNodesCmd();
							insertCmd.LayerName = currentDiagram.Model.DefaultLayerName;
							insertCmd.Nodes.Concat(clipboardNodes);
							currentDiagram.ExecuteCommand(insertCmd);

							//GroupCmd grpcmd = new GroupCmd();
							//MoveCmd movenodescmd = null;
							
							//TODo: This function is called to move the link 
							//attached to the Pasted Nodes
                            ConnectLinkedNodes(clipboardNodes);
							
							foreach(INode node in clipboardNodes)
							{
								if (node.GetType() == typeof(FunctionBlock))
								{
									
									((FunctionBlock)node).WorkSheetId = this.Text;
									((FunctionBlock)node).LineStyle.DashStyle =  System.Drawing.Drawing2D.DashStyle.Solid;
									
								}
								IBounds2DF bounds = node as IBounds2DF;						
								if(bounds != null)
								{
									PointF worldpoint = currentDiagram.Controller.MouseLocation;
									if(currentDiagram.View != null)
										worldpoint = currentDiagram.View.ViewToWorld(currentDiagram.View.DeviceToView(new Point((int)currentDiagram.Controller.MouseLocation.X, (int)currentDiagram.Controller.MouseLocation.Y)));
									MoveCmd movenodescmd = new MoveCmd(worldpoint.X-bounds.X, worldpoint.Y-bounds.Y);
									movenodescmd.Nodes.Concat(clipboardNodes);
									currentDiagram.ExecuteCommand(movenodescmd);
									currentDiagram.Controller.SelectionList.Add(node);
								}
							}					
						}
					}	
					#endregion
	
					//clear all the collections and update views			
					Main.GlobalCutList.Clear();
					//globalCollection.Clear();
					Main.GlobalPasteList.Clear();
					Main.CutOperationPerformed = false;
					Main.CopyOperationPerformed = false;
					this.PastePerformed = false;
					//diagram.Model.UpdateViews();
					currentDiagram.Controller.View.Draw();
					currentDiagram.Controller.View.Refresh();
				}
			}
			diagram.Controller.ClearHistory();
		}

private void RemoveLinks(NodeCollection nodeColl)
		{
			bool hasLinks = false;
            
			for (int count = 0; count < nodeColl.Count ; count++)
			{
				if (nodeColl[count].GetType() == typeof(Connection))
				{
					hasLinks = true;
					break;
				}
			}
			
			if (hasLinks == true)
			{
				IEnumerator nodeEnum = nodeColl.GetEnumerator();
				RemoveNodesCmd rmnodesCmd = new RemoveNodesCmd();
				NodeCollection links = new NodeCollection();

				while (nodeEnum.MoveNext())
				{
					if (nodeEnum.Current.GetType() == typeof(Connection))
					{
						links.Add(((Connection)nodeEnum.Current));
					}
					rmnodesCmd.Nodes.Concat(links);
				}
				diagram.Controller.ExecuteCommand(rmnodesCmd);
			}
		}
		